# This program realizes a simulated user login interface.
# Note that this is definetly not a safe way of authentification.
# Created by Min LU, 2021-07-28, updated 2022-04-08
from medialib import *

initialize() # always the first instruction of the program

def draw_image(filename):
    clear()
    draw(filename, 200, 100, 400, 400)

def add_new_user(username, password):
    with open("login.txt", "a") as f:
        f.write(username+":"+password+"\n")

lines = open("login.txt", "r", encoding="utf-8").readlines() # read all the lines from the text file
login_dict = {}
for line in lines:  # parse each line and store the username and password into a dictionary
    user = line.strip().split(':')
    username = user[0]
    password = user[1]
    login_dict[username] = password # the key is username and the value is password

logged_in = False

while not logged_in:  # loop until logged in (can use while True as well)
    draw_image("login.png")
    username = input("Username: ") # get username
    if username in login_dict.keys():
        # username exists
        draw_image("password.png")
        password = input("Password: ") # get password
        if login_dict[username] == password: # check the password
            # password is correct
            draw_image("welcome.png")
            print("Welcome!")
            logged_in = True # can break here if using while True
        else:
            # password is wrong
            draw_image("wrong_password.png")
            print("Password is incorrect!")
    else:
        # username does not exist
        draw_image("wrong_user.png")
        print("No such user!")
        add_new = input("Do you want to create a new account for the user (yes/no): ")
        if add_new == "yes":
            # add new user account
            draw_image("password.png")
            password = input("Password: ")
            add_new_user(username, password) # write to file, see the definition above
            print("New user created!")
            draw_image("welcome.png")
            logged_in = True # can break here if use while True
            # if not finish here, and goes to login screen again
            # should add the new account to the login_dict as
            # login_dict[username] = password
        else:
            continue # this will skip the wait_mouse_leftclick() below
    wait_mouse_leftclick()

print("done")

all_done() # always the last instruction of the program
