from medialib import *

initialize()

# draw the two initial pizza images
left_rect = [0, 100, 400, 400]
right_rect = [400, 100, 400, 400]
draw("pizza1.png", left_rect[0], left_rect[1], left_rect[2], left_rect[3])
draw("pizza2.png", right_rect[0], right_rect[1], right_rect[2], right_rect[3])

# loop until one of the pizzas is clicked
while True:
    wait_mouse_leftclick() # the program stops here and waits for a mouse click
    mouse_x, mouse_y = get_mouse_pos() # when mouse clicked, get the mouse position
    print("mouse at: (" , mouse_x, ",", mouse_y, ")") # print the mouse position
    # see if the mouse clicked inside the pizza
    # Solution 1: check if the mouse position is inside the rect of the image 
    if point_inside_rect(mouse_x, mouse_y, left_rect[0], left_rect[1], left_rect[2], left_rect[3]):
        # left selected
        pizza_img = "pizza1.png"
        break
    # Solution 2: check if the distance from the mouse position to the center of the pizza is smaller than the radius
    elif distance(mouse_x, mouse_y, right_rect[0]+right_rect[2]*0.5, right_rect[1]+right_rect[3]*0.5) <= right_rect[2] * 0.5:
        # right selected
        pizza_img = "pizza2.png"
        break

# draw selected pizza
clear()
pizza_rect = {"x": 200, "y": 0, "w": 600, "h": 600}
draw(pizza_img, pizza_rect["x"], pizza_rect["y"], pizza_rect["w"], pizza_rect["h"])

# draw materials (use the example images, or you can find your own versions)

# design the interactive pizza making game and complete code

# for example, use a while loop to get the position of each mouse click
# if a material is clicked, choose the material
# if the click is inside the pizza, draw the material image

wait_mouse_leftclick()

all_done()