# Final Exercise 2 Reference Solution
# Created by Min Lu 2021-08-16 modified 2022-07-21

from medialib import *

initialize()

# draw the two initial pizza images
left_rect = [0, 100, 400, 400] # x, y, w, h of the rectangle
right_rect = [400, 100, 400, 400]
draw("pizza1.png", left_rect[0], left_rect[1], left_rect[2], left_rect[3])
draw("pizza2.png", right_rect[0], right_rect[1], right_rect[2], right_rect[3])

# loop until one of the pizzas is clicked
while True:
    wait_mouse_leftclick() # the program stops here and waits for a mouse click
    mouse_x, mouse_y = get_mouse_pos() # when mouse clicked, get the mouse position
    print("mouse at: (" , mouse_x, ",", mouse_y, ")") # print the mouse position
    # see if the mouse clicked inside the pizza
    # Solution 1: check if the mouse position is inside the rect of the image 
    if point_inside_rect(mouse_x, mouse_y, left_rect[0], left_rect[1], left_rect[2], left_rect[3]):
        # left selected
        pizza_img = "pizza1.png"
        break
    # Solution 2: check if the distance from the mouse position to the center of the pizza is smaller than the radius
    elif distance(mouse_x, mouse_y, right_rect[0]+right_rect[2]*0.5, right_rect[1]+right_rect[3]*0.5) <= right_rect[2] * 0.5:
        # right selected
        pizza_img = "pizza2.png"
        break

# draw selected pizza
clear()
# here shows another way of storing the rectangle: using a dict instead of a list
pizza_rect = {"x": 200, "y": 0, "w": 600, "h": 600}
draw(pizza_img, pizza_rect["x"], pizza_rect["y"], pizza_rect["w"], pizza_rect["h"])

# draw material on the left for selection
# rectangles stored as dictionaries
cheeze_rect = {"x": 50, "y": 50, "w": 100, "h": 100}
cucumber_rect = {"x": 50, "y": 150, "w": 100, "h": 100}
pineapple_rect = {"x": 50, "y": 250, "w": 100, "h": 100}
salami_rect = {"x": 50, "y": 350, "w": 100, "h": 100}
tomato_rect = {"x": 50, "y": 450, "w": 100, "h": 100}
draw("cheeze.png", cheeze_rect["x"], cheeze_rect["y"], cheeze_rect["w"], cheeze_rect["h"])
draw("cucumber.png", cucumber_rect["x"], cucumber_rect["y"], cucumber_rect["w"], cucumber_rect["h"])
draw("pineapple.png", pineapple_rect["x"], pineapple_rect["y"], pineapple_rect["w"], pineapple_rect["h"])
draw("salami.png", salami_rect["x"], salami_rect["y"], salami_rect["w"], salami_rect["h"])
draw("tomato.png", tomato_rect["x"], tomato_rect["y"], tomato_rect["w"], tomato_rect["h"])

pizza_center_x, pizza_center_y = 500, 300 # coordinates of the center of the pizza
radius = 250 # radius of the pizza (to accept the mouse click to draw the material image)
material_img = None # selected material image (initialized as None)
while True:
    wait_mouse_leftclick()  # the program stops here and waits for a mouse click
    mouse_x, mouse_y = get_mouse_pos()  # when mouse clicked, get the mouse position
    print("mouse at: (" , mouse_x, ",", mouse_y, ")")
    if point_inside_rect(mouse_x, mouse_y, cheeze_rect["x"], cheeze_rect["y"], cheeze_rect["w"], cheeze_rect["h"]):
        # cheeze clicked, the image to draw will be "cheeze.png"
        material_img = "cheeze.png"
        print("cheeze selected")
    elif point_inside_rect(mouse_x, mouse_y, cucumber_rect["x"], cucumber_rect["y"], cucumber_rect["w"], cucumber_rect["h"]):
        # cucumber clicked, the image to draw will be "cucumber.png"
        material_img = "cucumber.png"
        print("cucumber selected")
    elif point_inside_rect(mouse_x, mouse_y, pineapple_rect["x"], pineapple_rect["y"], pineapple_rect["w"], pineapple_rect["h"]):
        # pineapple clicked, the image to draw will be "pineapple.png"
        material_img = "pineapple.png"
        print("pineapple selected")
    elif point_inside_rect(mouse_x, mouse_y, salami_rect["x"], salami_rect["y"], salami_rect["w"], salami_rect["h"]):
        # salami clicked, the image to draw will be "salami.png"
        material_img = "salami.png"
        print("salami selected")
    elif point_inside_rect(mouse_x, mouse_y, tomato_rect["x"], tomato_rect["y"], tomato_rect["w"], tomato_rect["h"]):
        # tomato clicked, the image to draw will be "tomato.png"
        material_img = "tomato.png"
        print("tomato selected")
    elif material_img is not None and distance(mouse_x, mouse_y, pizza_center_x, pizza_center_y) <= radius:
        # the click is inside the pizza, and the material is selected,
        # then draw the material, using the clicked coodinates as the center
        draw(material_img, mouse_x - 32, mouse_y - 32, 64, 64)
        print("draw", material_img)
    # you can design a way to quit the loop and finish the pizza

# can save the image of the pizza using save_screen function of medialib
all_done()