# A program drawing horizontal bars to visualize a given list of data and their average value
# Created by Your Name, 2021-MM-DD
# make sure medialib.py is at the same folder as this file
## magic code #########################
from medialib import *
initialize() # always the first instruction of the program
#######################################

# Draw a horizontal bar, which is a rectangle from top-left coordinates (x, y)
# with height (bar_breadth) and width (bar_length) and color (r, g, b, 0~255).
# Text of the value (number) will be drawn on the right of the bar
def draw_horizontal_bar(value, x, y, bar_breadth, bar_length, r, g, b):
    # Draw the horizontal bar (rectangle)
    rect(x, y, bar_length, bar_breadth, r, g, b)

    # Draw the text
    value_str = "{:.3f}".format(value)  # convert the value to str (3 decimal points)
    text_x = x + bar_length + 10  # calculate the top-left coordinates of the text
    text_y = y
    text(value_str, text_x, text_y, bar_breadth, r, g, b)  # draw text

# data to visualize (estimated population of Fukuoka city in 2000, 2005, 2010, 2015, and 2020, in M)
data = [1.341, 1.401, 1.464, 1.539, 1.601]

# definitions for the bars
origin_x = 100  # the top-left coordinates of the first bar, all the bars have the same x,
origin_y = 100  # but the y coordinates should be calculated
bar_interval = 30  # distance between 2 neighboring bars ()
bar_max_length = 600  # a bar of max value 2.000 will have a max length 600
bar_max_value = 2.000  # you need to calculate the length of each bar as value / max_value * max_lengh
bar_breadth = 30  # breadth of each bar
bar_color = [255, 255, 0]  # color of the data bar and text (yellow), you can change as you like
bar_color_average = [135, 206, 235]  # color of the average value bar and text (skyblue), you can change as you like

# draw the first bar
print("Draw the first bar, value={}".format(data[0]))
bar_length = data[0] / bar_max_value * bar_max_length  # calculate the bar's length
x = origin_x
y = origin_y
# call draw_horizontal_bar function to draw the bar and text
draw_horizontal_bar(data[0], x, y, bar_breadth, bar_length, bar_color[0], bar_color[1], bar_color[2])
wait_mouse_leftclick()

# draw the second bar
print("Draw the second bar, value={}".format(data[1]))
bar_length = data[1] / bar_max_value * bar_max_length  # calculate the bar's length
offset_y = (bar_interval + bar_breadth) * 1  # calculate the coordinates of the bar
y = origin_y + offset_y  # x should be the same, but y should move (bar_interval + bar_breadth) pixels below
# compelete the code here to draw the second bar (use draw_horizontal_bar function)

wait_mouse_leftclick()

# draw the third bar
print("Draw the third bar, value={}".format(data[2]))
# compelete the code here to draw the third bar

wait_mouse_leftclick()

# draw the forth bar
# complete the code by yourself


# draw the fifth bar
# complete the code by yourself


# draw the average bar
# 1. calculate the average value

# print("Draw the average bar, value={}".format(???))

# 2. calculate the bar_length

# 3. calculate the offset_y and y coordinate of the bar

# 4. draw the bar use the bar_color_average

# 5. wait for mouse press


print("done")

all_done() # always the last instruction of the program
