# Plot the given data to figures with matplotlib
# Use medialib to load and show the saved image files of the figures
# Created by Your Name, 2022-05-XX
from matplotlib import pyplot as plt
from medialib import *

initialize() # always the first instruction of the program

day = []  # days: 1, 2, 3, ...
fukuoka = []  # Number of cases increased each day in Fukuoka
tokyo = []  # Number of cases increased each day in Tokyo
osaka = []  # Number of cases increased each day in Osaka
hokkaido = []  # Number of cases increased each day in Hokkaido

# 0. load data from file
lines = open("data.csv", "r", encoding="utf-8").readlines()
for i in range(1, len(lines)):
    _nums = lines[i].split(",")
    day.append(int(_nums[0]))
    fukuoka.append(int(_nums[1]))
    tokyo.append(int(_nums[2]))
    osaka.append(int(_nums[3]))
    hokkaido.append(int(_nums[4]))

# 1. use matplotlib to plot the figures and save to files
# you can choose the type of graph you like and customize it
# Example: plot the figure (bar chart, green, as an example) for Fukuoka
# Remember to remove the following lines after your function is defined
plt.bar(day, fukuoka, color="g")
# Set up the title, labels, etc.
plt.xlabel("Day (in May)")
plt.ylabel("Count of Cases")
plt.title("Daily Cases Confirmed in Fukuoka")
# plt.show()  # can uncomment this line for test
plt.savefig("fukuoka.png")
plt.clf()  # clear the figure before drawing the next one

"""
It is not a good idea to write the above lines another 3 times.
So, you are expected to define a function and call it 4 times to do the job.
Consider the arguments needed when creating the function.
You may call the function like:
plot_bars_to_file(day, fukuoka, "r", "Daily Cases in Fukuoka", "Day", "Case Count", "fukuoka.png")
plot_bars_to_file(day, tokyo, "g", ...)
plot_bars_to_file(day, osaka, "b", ...)
plot_bars_to_file(day, hokkaido, "m", ...)
to plot the figures.
Finally, remember to remove the above example code for a figure of Fukuoka.
"""

# 2. Use "draw" function of medialib to load and draw the figures on the window
# Example:
draw("fukuoka.png", 0, 0, 400, 300)
# Arguments: filename, x, y, width, height
# Consider the coordinates and sizes of other figures.

wait_mouse_leftclick()

print("done")

all_done() # always the last instruction of the program
