# Draw the image of the dice face of a inputted integer
# Created by Min Lu, 2022-04-08
from medialib import *

initialize() # always the first instruction of the program

# Draw the image of dice face according to the number n
# if we do not know elif
def draw_dice_face(n):
    if n == 1:
        draw("dice1.png", 200, 100, 400, 400)
        return # it is also fine if no return here,
               # but it is better to prevent the excution of the following "if" statements
    if n == 2:
        draw("dice2.png", 200, 100, 400, 400)
        return
    if n == 3:
        draw("dice3.png", 200, 100, 400, 400)
        return
    if n == 4:
        draw("dice4.png", 200, 100, 400, 400)
        return
    if n == 5:
        draw("dice5.png", 200, 100, 400, 400)
        return
    if n == 6:
        draw("dice6.png", 200, 100, 400, 400)
        return
    if n < 1 or n > 6:
        print("Number out of range!")
        draw("dice0.png", 200, 100, 400, 400)

# if we use elif
def draw_dice_face_v2(n):
    if n == 1:
        draw("dice1.png", 200, 100, 400, 400)
    elif n == 2:
        draw("dice2.png", 200, 100, 400, 400)
    elif n == 3:
        draw("dice3.png", 200, 100, 400, 400)
    elif n == 4:
        draw("dice4.png", 200, 100, 400, 400)
    elif n == 5:
        draw("dice5.png", 200, 100, 400, 400)
    elif n == 6:
        draw("dice6.png", 200, 100, 400, 400)
    else:
        print("Number out of range!")
        draw("dice0.png", 200, 100, 400, 400)

# a much more concise solution
# make use of the relation between n and the file name
def draw_dice_face_v3(n):
    if n >= 1 and n <= 6:
        draw("dice{}.png".format(n), 200, 100, 400, 400)
        # or: draw("dice" + str(n) + ".png", 200, 100, 400, 400)
    else:
        print("Number out of range!")
        draw("dice0.png", 200, 100, 400, 400)

# Use input function to get an integer number
n = int(input("Input a integer (1-6): "))
# Call the function above to draw the dice face according to n
draw_dice_face_v3(n)
wait_mouse_leftclick()

print("done")

all_done() # always the last instruction of the program
