# Write your code here :-)
# A simple dice game - a more concise solution
# Created by Min LU, 2021-06-17, updated 2022-04-08, 2022-06-09
from medialib import *
from random import randint

initialize() # always the first instruction of the program

# Draw the image of dice face according to the number n (1-6)
# and the side ("left" or "right")
def draw_dice_face(n, side):
    if n >= 1 and n <= 6:
        image = "dice" + str(n) + ".png"
    else:
        print("Number n is out of range!")
        return

    if side == "left":
        x = 100
    elif side == "right":
        x = 500
    else:
        print("<side> should be either left or right!")
        return
        
    y, w, h = 100, 200, 200
    draw(image, x, y, w, h)

# Draw the image of a gold or silver medal
# according to the place (1 or 2)
# and the side ("left" or "right")
def draw_medal(place, side):
    if place == 1 or place == 2:
        image = "medal" + str(place) + ".png"
    else:
        print("<place> is out of range!")
        return

    if side == "left":
        x = 100
    elif side == "right":
        x = 500
    else:
        print("<side> should be either left or right!")
        return

    y, w, h = 300, 200, 200
    draw(image, x, y, w, h)

wait_mouse_leftclick()

# Roll the 1st dice
dice1 = randint(1, 6)
# Call the function above to draw the dice face according to n
draw_dice_face(dice1, "left")

wait_mouse_leftclick()

# Roll the 2nd dice
dice2 = randint(1, 6)
draw_dice_face(dice2, "right")

wait_mouse_leftclick()

# Check which side wins and draw the medals
if dice1 > dice2:
    place_l, place_r = 1, 2
elif dice1 < dice2:
    place_l, place_r = 2, 1
else:
    place_l, place_r = 1, 1
draw_medal(place_l, "left")
draw_medal(place_r, "right")

wait_mouse_leftclick()
print("done")

all_done() # always the last instruction of the program
