# A program drawing a grayscale pixel art image from the pixel values in a text file
# Created by Min Lu, 2022-04-08
# make sure medialib.py is at the same folder as this file
## magic code #########################
from medialib import *
initialize() # always the first instruction of the program
#######################################

def read_pixels(filename):
    result = []
    with open(filename, "r", encoding="utf-8") as f:
        f.readline()
        size = [int(s) for s in f.readline().split()]
        #print(size)
        max_value = int(f.readline())
        for i in range(size[0]):
            row = f.readline().split() # a list of strings
            # scale the pixel values to 0~255
            result.append([int(p) * max_value / 255 for p in row])
    return result

pixels = read_pixels("image.pgm")
#print(pixels)

pixel_size = 6  # size of each pixel
for i in range(len(pixels)):
    for j in range(len(pixels[i])):
        rect(j * pixel_size, i * pixel_size, pixel_size, pixel_size, pixels[i][j], pixels[i][j], pixels[i][j])

wait_mouse_leftclick()

# BONUS QUESTION:
# Draw the positive image reversed from the original image beside it

origin_x = 400  # if start from the middle of the window
# origin_x = (j + 1) * pixel_size  # if start just next to the negative image
for i in range(len(pixels)):
    for j in range(len(pixels[i])):
        # (r, g, b) => (255-r, 255-g, 255-b) will reverse the color of the pixel
        rect(origin_x + j * pixel_size, i * pixel_size, pixel_size, pixel_size, 255 - pixels[i][j], 255 - pixels[i][j], 255 - pixels[i][j])

wait_mouse_leftclick()

print("done")

all_done() # always the last instruction of the program
