# Write your code here :-)
# A simple dice game
# Created by Min LU, 2021-07-11, updated 2022-04-08
from medialib import *
from random import randint

initialize() # always the first instruction of the program

# Draw the image of dice face according to the number n (1-6)
# and the side ("left" or "right")
def draw_dice_face(n, side):
    if n == 1:
        image = "dice1.png"
    elif n == 2:
        image = "dice2.png"
    elif n == 3:
        image = "dice3.png"
    elif n == 4:
        image = "dice4.png"
    elif n == 5:
        image = "dice5.png"
    else:
        image = "dice6.png"

    if side == "left":
        x = 100
    else:
        x = 500
    y, w, h = 100, 200, 200

    draw(image, x, y, w, h)

# Draw the image of a gold or silver medal
# according to the place (1 or 2)
# and the side ("left" or "right")
def draw_medal(place, side):
    if place == 1:
        image = "medal1.png"
    elif place == 2:
        image = "medal2.png"

    if side == "left":
        x = 100
    else:
        x = 500
    y, w, h = 300, 200, 200

    draw(image, x, y, w, h)

count = 0
dice1 = 0  # initialize dice1 & dice2
dice2 = 7  # just make sure dice1 != dice2
while dice1 != dice2:
    wait_mouse_leftclick()
    clear()

    # Roll the 1st dice
    dice1 = randint(1, 6)
    # Call the function above to draw the dice face according to n
    draw_dice_face(dice1, "left")

    wait_mouse_leftclick()

    # Roll the 2nd dice
    dice2 = randint(1, 6)
    draw_dice_face(dice2, "right")

    wait_mouse_leftclick()

    count += 1
    # Check which side wins and draw the medals
    if dice1 > dice2:
        place_l, place_r = 1, 2
    elif dice1 < dice2:
        place_l, place_r = 2, 1
    else:
        place_l, place_r = 1, 1
    draw_medal(place_l, "left")
    draw_medal(place_r, "right")
else:
    print("It is a tied game.")
    print("Number of rounds: " + str(count))

wait_mouse_leftclick()
print("done")

all_done() # always the last instruction of the program
